/*
 * linux/drivers/char/fiona_keymap.c
 *
 * Copyright 2005, Lab126.com <nvaccaro@lab126.com>
 *
 * Keyboard map for the Fiona Platform
 */

#include <linux/config.h>

#ifdef CONFIG_ARCH_FIONA

#include "fiona_keymap.h"

#define KEY_NONE    KEY_RESERVED

/* Keyboard mapping for Fiona IOC keyboard */
unsigned char kbd_ioc_xlate_char[FIONA_KEYMAP_SIZE] = 
    "17EOGX!#"          //!=KEY_COFFEE, #=KEY_PROG1,        /* 0x00 - 0x07 */
    "28RPHC:^"          //^=KEY_MENU,                       /* 0x08 - 0x0F */
    "39TAJV(&"          // (=KEY_PAGEDOWN, &=KEY_LEFTSHIFT, /* 0X10 - 0X17 */
    "40YSKB_@"          // _=KEY_PAGEUP, @=KEY_PROPS,       /* 0X18 - 0X1F */
    "5QUDLN. "                                              /* 0x20 - 0x27 */
    "6WIFZM/ "                                              /* 0X28 - 0X2F */
    "><`\n"           // KEY_VOLUMEUP, KEY_VOLUMEDOWN, 
                        // KEY_BACKSPACE, KEY_ENTER,        /* 0X30 - 0X33 */
    "?[]"               // KEY_SEARCH, KEY_SHOP, KEY_PROG2, /* 0X34 - 0X36 */

    "*********"
    //KEY_NONE, KEY_NONE, KEY_NONE, KEY_NONE, KEY_NONE,     /* 0x37 - 0x3F */
    //KEY_NONE, KEY_NONE, KEY_NONE, KEY_NONE,               /* Not defined */
    
    "+-";
    //KEY_SCROLLUP, KEY_SCROLLDOWN,                         /* 0X40 - 0X41 */


#if 0
unsigned char kbd_ioc_xlate_x[FIONA_KEYMAP_SIZE] =  {
    XK_1, XK_7, XK_E, XK_O, XK_G, XK_X, XK_COFFEE, XK_PROG1,        /* 0x00 - 0x07 */
    XK_2, XK_8, XK_R, XK_P, XK_H, XK_C, XK_semicolon, XK_MENU,      /* 0x08 - 0x0F */
    XK_3, XK_9, XK_T, XK_A, XK_J, XK_V, XK_PAGEDOWN, XK_LEFTSHIFT,  /* 0X10 - 0X17 */
    XK_4, XK_0, XK_Y, XK_S, XK_K, XK_B, XK_PAGEUP, XK_PROPS,        /* 0X18 - 0X1F */
    XK_5, XK_Q, XK_U, XK_D, XK_L, XK_N, XK_period, XK_space,           /* 0x20 - 0x27 */
    XK_6, XK_W, XK_I, XK_F, XK_Z, XK_M, XK_slash, XK_space,         /* 0X28 - 0X2F */
    XK_VOLUMEUP, XK_VOLUMEDOWN, XK_BACKSPACE, XK_ENTER,                 /* 0X30 - 0X33 */
    XK_SEARCH, XK_SHOP, XK_PROG2,                                        /* 0X34 - 0X36 */

    KEY_NONE, KEY_NONE, KEY_NONE, KEY_NONE, KEY_NONE,                       /* 0x37 - 0x3F */
    KEY_NONE, KEY_NONE, KEY_NONE, KEY_NONE,                                 /* Not defined */
    
    XK_SCROLLUP, XK_SCROLLDOWN                                            /* 0X40 - 0X41 */
};

#endif

unsigned char kbd_ioc_xlate[FIONA_KEYMAP_SIZE] =  {
    KEY_1, KEY_7, KEY_E, KEY_O, KEY_G, KEY_X, KEY_COFFEE, KEY_PROG1,        /* 0x00 - 0x07 */
    KEY_2, KEY_8, KEY_R, KEY_P, KEY_H, KEY_C, KEY_SEMICOLON, KEY_MENU,      /* 0x08 - 0x0F */
    KEY_3, KEY_9, KEY_T, KEY_A, KEY_J, KEY_V, KEY_PAGEDOWN, KEY_LEFTSHIFT,  /* 0X10 - 0X17 */
    KEY_4, KEY_0, KEY_Y, KEY_S, KEY_K, KEY_B, KEY_PAGEUP, KEY_PROPS,        /* 0X18 - 0X1F */
    KEY_5, KEY_Q, KEY_U, KEY_D, KEY_L, KEY_N, KEY_DOT, KEY_SPACE,           /* 0x20 - 0x27 */
    KEY_6, KEY_W, KEY_I, KEY_F, KEY_Z, KEY_M, KEY_SLASH, KEY_SPACE,         /* 0X28 - 0X2F */
    KEY_VOLUMEUP, KEY_VOLUMEDOWN, KEY_BACKSPACE, KEY_ENTER,                 /* 0X30 - 0X33 */
    KEY_SEARCH, KEY_SHOP, KEY_PROG2,                                        /* 0X34 - 0X36 */

    KEY_NONE, KEY_NONE, KEY_NONE, KEY_NONE, KEY_NONE,                       /* 0x37 - 0x3F */
    KEY_NONE, KEY_NONE, KEY_NONE, KEY_NONE,                                 /* Not defined */
    
    KEY_SCROLLUP, KEY_SCROLLDOWN                                            /* 0X40 - 0X41 */
};

#endif // CONFIG_ARCH_FIONA
