/******************************************************************
 *
 *	File:	ppoke.h
 *
 *	Author:	Nick Vaccaro	
 *
 *	Description: Definitions for the ppoke driver, a driver
 *		designed to access Kernel (system) space to read
 *		and write memory addresses.
 *			
 ******************************************************************/

#ifndef __PPOKE__
#define __PPOKE__

// Error values
#ifndef NOERR
#define NOERR	0
#endif

typedef struct DrvrGlobalsType {
	int	majorNumber;	/* Major Number (should be 207) */
} DrvrGlobalsType, *DrvrGlobalsTypePtr;

// Peek and Poke size constants
typedef enum sizeType {
	kByteSize = 1,
	kShortSize = 2,
	kLongSize = 4
}sizeType;

typedef struct PPokeRec {
	unsigned long	addr;	/* address to peek or poke */
	sizeType	size;	/* size of data to peek or poke */
	unsigned long	value;	/* value to write for poke, 
					or value read from peek */
}PPokeRec, *PPokeRecPtr;


// ppoke IOCTL constants
#define kIOCTLPPOKEMagicNumber	'p'

#define PPOKE_IOCTLPEEK		_IOR(kIOCTLPPOKEMagicNumber, 0, unsigned long *)
#define PPOKE_IOCTLPOKE		_IOW(kIOCTLPPOKEMagicNumber, 1, unsigned long *)
#define PPOKE_IOCTLLast		1

#endif /* __PPOKE__*/
