/*
 * Copyright (C) 2006 Nick Vaccaro, Lab126, Inc.    <nvaccaro@lab126.com>
 * (C) Copyright 2000
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <exports.h>
#include <asm/arch/pxa-regs.h>


// The serial send and rx timeouts
#define OSCR_USECONDS       4                           // 4 OSCR ticks/uSec
#define OSCR_MSECONDS       (1000*OSCR_USECONDS)        // 1000 uSec/Sec
#define OSCR_SECONDS        (1000000*OSCR_USECONDS)     // 1000000 uSec/Sec
#define IOC_SEND_TIMEOUT    (4 * OSCR_SECONDS)  // 4 second timeout
#define IOC_RESET_PXA_COMMAND   0x16


int sample_diags(int argc, char *argv[])
{
    int lsr, data;

	/* Print the ABI version */
	printf ("Welcome to the User Diagnostics Placeholder !!\n\n");

	printf ("Hit any key or button to exit diagnostics... ");

    /********************************************
     * Initialize IOC UART
     ********************************************/
    CKEN = ((CKEN & CKEN_RESPECT) | (CKEN7_BTUART));
    BTIER = 0;
    BTFCR = 0x07;                   // FIFO mode, 1 byte interrupt, tx empty int, clear fifos
    BTLCR = LCR_DLAB;               // Prepare to access DLL
    BTDLL = 0x60;                   // Set port speed to 9600 Baud
    BTDLH = 0x0;                    // Set port speed to 9600 Baud
    BTLCR = (LCR_WLS0 | LCR_WLS1);  // 8-bit chars, No parity, and 1 stop bit
    BTIER = IER_UUE;                // Enable this UART

    /********************************************
     * Watch for a character
     ********************************************/
    /* Reset the board on next character seen */
    while (!tstc()) {
        // Check for IOC keys...
        lsr = BTLSR;
        if (lsr & 1)  {
            data = (BTRBR & 0xFF);
            if (data == 0xF0) {
                // It's a keypress packet, good enough...
                goto reboot_board;
            }
        }
    }
    (void) getc();
    printf ("\n\n");

reboot_board:

    /* reboot the machine */
    printf("Rebooting machine...\n");

    // Write cmd to IOC
    BTTHR = IOC_RESET_PXA_COMMAND;

    // Wait for IOC to reboot us...
    while (1);

    // Should never get here, but keep the compiler warnings happy */
    return(0);
}
