#!/usr/bin/python
#
#	bootblock_check.py <filename>
#
# After the bootblock code, there is a marker that helps identify the end of
# the bootblock code.  First there is a global that contains the address of
# of the first location after the boot block code.  This is followed by a
# marker of 0xEEEEEEEE, 0xEEEEEEEE, 0xEEEEEEEE.
#
# So, if the bootblock is exactly 1KB in length, the address will be
# located at 1024, and the pattern will start at (1024+4).
#
# Exits with a return code of zero if the bootblock is less than 1024 bytes
# in length.

from sys import argv, exit
from re import search

filename = argv[1]

infile = file(filename, 'rb')

data = infile.read()

infile.close()

pattern = '\xee'*12

match_obj = search(pattern, data)

if match_obj == None:
    print "### Error: No pattern found."
    exit(2)

if match_obj.start() > (1024+4):
    print "### Error: Boot block is too big (%d bytes)" % match_obj.start()
    exit(1)

exit(0)
